package cz.frantovo.nekurak.rest;

import cz.frantovo.nekurak.posluchac.OchranaProtiCSRF;
import cz.frantovo.nekurak.util.HttpPozadavek;
import cz.frantovo.nekurak.web.HledacSluzby;
import cz.frantovo.nekurak.xml.HlasXML;
import javax.servlet.http.HttpServletRequest;
import javax.ws.rs.Consumes;
import javax.ws.rs.POST;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.core.Context;

@Path("hlas")
public class HlasovaniREST {

	@Context
	HttpServletRequest pozadavek;
	private static final String MIME_XML = "text/xml";
	private static final String MIME_TEXT = "text/plain";
	private HledacSluzby hledac = new HledacSluzby();

	@POST
	@Consumes(MIME_XML)
	@Produces(MIME_TEXT)
	public String hlasuj(HlasXML xml) {
		zkontrolujCSRF(pozadavek, xml);
		hledac.getPodnikEJB().hlasuj(xml.getPodnik(), xml.isKourit(), HttpPozadavek.getIPadresa(pozadavek));
		return "ok";
	}

	private static void zkontrolujCSRF(HttpServletRequest pozadavek, HlasXML xml) throws RuntimeException {
		String csrfTokenOcekavany = (String) pozadavek.getSession().getAttribute(OchranaProtiCSRF.NAZEV_ATRIBUTU);
		String csrfTokenObdrzeny = xml.getCsrfToken();
		if (csrfTokenOcekavany == null || !csrfTokenOcekavany.equals(csrfTokenObdrzeny)) {
			throw new RuntimeException("CSRF token zaslaný klientem neodpovídá očekávanému.");
		}
	}
}
